package com.example.blum.neighbors;

import android.support.v7.app.AppCompatActivity;
import android.os.Bundle;
import android.view.View;
import android.view.ViewParent;
import android.widget.Button;
import android.widget.TableLayout;
import android.widget.TableRow;
import android.widget.Toast;

import java.util.Random;

public class MainActivity extends AppCompatActivity {

    int col_num =4;
    int row_num = 8;
    char[] letter = new  char[col_num*row_num];
    Random myRand = new Random();
    int firstIndex=-1;
    int secondIndex=-1;
    char firstChar;
    char secondChar;

    @Override
    protected void onCreate(Bundle savedInstanceState) {
        super.onCreate(savedInstanceState);
        setContentView(R.layout.activity_main);




        Button btnPlay = (Button) findViewById(R.id.btnPlay);

        btnPlay.setOnClickListener(new View.OnClickListener() {
            @Override
            public void onClick(View view) {
                createboard();
            }
        });

    }//end onCreate

    void createboard(){

        for(int i=0; i<row_num; i++) {
            TableLayout tlBoard = (TableLayout) findViewById(R.id.tlBoard);
            TableRow tr = new TableRow(this);
            tr.setLayoutParams(new TableRow.LayoutParams(TableRow.LayoutParams.MATCH_PARENT, TableRow.LayoutParams.WRAP_CONTENT));
            for(int j=0; j<col_num; j++) {
                Button b = new Button(this);
                b.setId(i*col_num + j);
                b.setLayoutParams(new TableRow.LayoutParams(TableRow.LayoutParams.MATCH_PARENT, TableRow.LayoutParams.WRAP_CONTENT));
            /* Add Button to row. */
                tr.addView(b);

                b.setOnClickListener(myListener);
            }
            /* Add row to TableLayout. */

            tlBoard.addView(tr, new TableLayout.LayoutParams(TableLayout.LayoutParams.MATCH_PARENT, TableLayout.LayoutParams.WRAP_CONTENT));
        }

    }

    Button.OnClickListener myListener = new Button.OnClickListener()  {

        @Override
        public void onClick(View view) {
            Button myButton = (Button) view;

            int butId = myButton.getId();
            //Toast.makeText(getApplicationContext(), "" + butId, Toast.LENGTH_SHORT).show();
            int myCol = butId % col_num;
            //Toast.makeText(getApplicationContext(), "col: " + myCol, Toast.LENGTH_SHORT).show();
            int myRow = butId / col_num;
            //Toast.makeText(getApplicationContext(), "row: " + myRow, Toast.LENGTH_SHORT).show();

            Button neighborButton;
            int myId;
            int resId;
            // neighbor above
            if(myRow!=0){
                myId =(myRow-1)*col_num + myCol;
                resId = getResources().getIdentifier(""+myId, "id", getPackageName());
                neighborButton  = (Button) findViewById(resId);
                neighborButton.setText("a");

                //to left
                if(myCol!=0){
                    myId =(myRow-1)*col_num + myCol-1;
                    resId = getResources().getIdentifier(""+myId, "id", getPackageName());
                    neighborButton  = (Button) findViewById(resId);
                    neighborButton.setText("al");
                }

                //to right
                if(myCol!=col_num-1){
                    myId =(myRow-1)*col_num + myCol+1;
                    resId = getResources().getIdentifier(""+myId, "id", getPackageName());
                    neighborButton  = (Button) findViewById(resId);
                    neighborButton.setText("ar");
                }
            }


            //same row
            //to left
            if(myCol!=0){
                resId = getResources().getIdentifier(""+(butId-1), "id", getPackageName());
                neighborButton  = (Button) findViewById(resId);
                neighborButton.setText("l");
            }

            //to right
            if(myCol!=col_num-1){
                resId = getResources().getIdentifier(""+(butId+1), "id", getPackageName());
                neighborButton  = (Button) findViewById(resId);
                neighborButton.setText("r");
            }


            //neighbor below
            if(myRow!=row_num-1){

                myId =(myRow+1)*col_num + myCol;
                resId = getResources().getIdentifier(""+myId, "id", getPackageName());
                neighborButton  = (Button) findViewById(resId);
                neighborButton.setText("b");

                //to left
                if(myCol!=0){
                    myId =(myRow+1)*col_num + myCol-1;
                    resId = getResources().getIdentifier(""+myId, "id", getPackageName());
                    neighborButton  = (Button) findViewById(resId);
                    neighborButton.setText("bl");
                }

                //to right
                if(myCol!=col_num-1){
                    myId =(myRow+1)*col_num + myCol+1;
                    resId = getResources().getIdentifier(""+myId, "id", getPackageName());
                    neighborButton  = (Button) findViewById(resId);
                    neighborButton.setText("br");
                }

            }

            /*
            TableRow myTableRow = (TableRow) myButton.getParent();
            int myCol = myTableRow.indexOfChild(myButton);
            TableLayout tlBoard = (TableLayout) findViewById(R.id.tlBoard);
            int myRow = tlBoard.indexOfChild(myTableRow);

            //Toast.makeText(getApplicationContext(), "myCol (zero-based): " + myCol, Toast.LENGTH_SHORT).show();
            //Toast.makeText(getApplicationContext(), "myRow (zerobased): " + myRow, Toast.LENGTH_SHORT).show();

            // neighbor above
            if(myRow!=0){

                Button aboveButton = (Button)  ((TableRow) tlBoard.getChildAt(myRow-1)).getChildAt(myCol);
                aboveButton.setText("a");

                //to left
                if(myCol!=0){
                    Button aboveleftButton = (Button)  ((TableRow) tlBoard.getChildAt(myRow-1)).getChildAt(myCol-1);
                    aboveleftButton.setText("al");
                }

                //to right
                if(myCol!=col_num-1){
                    Button aboverightButton = (Button)  ((TableRow) tlBoard.getChildAt(myRow-1)).getChildAt(myCol+1);
                    aboverightButton.setText("ar");
                }
            }


            //same row
            //to left
            if(myCol!=0){
                Button aboveleftButton = (Button)  ((TableRow) tlBoard.getChildAt(myRow)).getChildAt(myCol-1);
                aboveleftButton.setText("l");
            }

            //to right
            if(myCol!=col_num-1){
                Button aboverightButton = (Button)  ((TableRow) tlBoard.getChildAt(myRow)).getChildAt(myCol+1);
                aboverightButton.setText("r");
            }


            //neighbor below
            if(myRow!=row_num-1){
                Button belowButton = (Button)  ((TableRow) tlBoard.getChildAt(myRow+1)).getChildAt(myCol);
                belowButton.setText("b");

                //to left
                if(myCol!=0){
                    Button belowleftButton = (Button)  ((TableRow) tlBoard.getChildAt(myRow+1)).getChildAt(myCol-1);
                    belowleftButton.setText("bl");
                }

                //to right
                if(myCol!=col_num-1){
                    Button belowrightButton = (Button)  ((TableRow) tlBoard.getChildAt(myRow+1)).getChildAt(myCol+1);
                    belowrightButton.setText("br");
                }

            }
*/
        }
    };

}//end MainActivity
